<?php
/*
 *
 * ElbiaAdmin PHP-lib version 3.1.9
 * Copyright (c) 2012-2024, Jozef Sudolsky, ELBIA, s. r. o. (jozef@sudolsky.sk)
 * All rights reserved.
 * BSD Licence
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     1. Redistributions of source code must retain the above copyright notice,
 *        this list of conditions and the following disclaimer.
 *
 *     2. Redistributions in binary form must reproduce the above copyright
 *        notice, this list of conditions and the following disclaimer in the
 *        documentation and/or other materials provided with the distribution.
 *
 *     3. Neither the name of ElbiaAdmin PHP-lib nor the names of its
 *        contributors may be used to endorse or promote products derived from
 *        this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

require_once("ealibCore.php");

class ElbiaAdminInvoicing extends ElbiaAdmin {

	const OK_STATE = "ok";

	function getCompany($id) {
		return $this->_do_command("getCompany", array($this->token, $id), "I");
	}

	function getDocument($gid) {
		return $this->_do_command("getDocument", array($this->token, $gid), "I");
	}

	function listCompanies($pagingOffset, $pagingCount, $filName=NULL, $filFirstname=NULL, $filLastname=NULL, $filStreet=NULL, $filCity=NULL, $filZip=NULL, $filCountry=NULL, $filEmail=NULL, $filCid=NULL, $filTid=NULL, $filVid=NULL, $filInvoiceVat=NULL, $filNamePost=NULL, $filStreetPost=NULL, $filCityPost=NULL, $filZipPost=NULL, $filCountryPost=NULL) {
		return $this->_do_command("listCompanies", array($this->token, $pagingOffset, $pagingCount, $filName, $filFirstname, $filLastname, $filStreet, $filCity, $filZip, $filCountry, $filEmail, $filCid, $filTid, $filVid, $filInvoiceVat, $filNamePost, $filStreetPost, $filCityPost, $filZipPost, $filCountryPost), "I");
	}

	function listDocuments($pagingOffset, $pagingCount, $filId=NULL, $filVS=NULL, $filFkInvoice=NULL, $filFkType=NULL, $filName=NULL, $filStreet=NULL, $filCity=NULL, $filZip=NULL, $filCountry=NULL, $filCid=NULL, $filTid=NULL, $filVid=NULL, $filFkCurrency=NULL, $filFkLanguage=NULL, $filIssueDateFrom=NULL, $filIssueDateTo=NULL, $filDeliveryDateFrom=NULL, $filDeliveryDateTo=NULL, $filInvoiceVat=NULL, $filAdvancePayment=NULL, $filMaturityDays=NULL, $filPrepaid=NULL, $filKeyhash=NULL, $filItemLabel=NULL, $filPaid=NULL) {
		return $this->_do_command("listDocuments", array($this->token, $pagingOffset, $pagingCount, $filId, $filVS, $filFkInvoice, $filFkType, $filName, $filStreet, $filCity, $filZip, $filCountry, $filCid, $filTid, $filVid, $filFkCurrency, $filFkLanguage, $filIssueDateFrom, $filIssueDateTo, $filDeliveryDateFrom, $filDeliveryDateTo, $filInvoiceVat, $filAdvancePayment, $filMaturityDays, $filPrepaid, $filKeyhash, $filItemLabel, $filPaid), "I");
	}

	function setDocumentPaid($gid, $paid) {
		return $this->_do_command("setDocumentPaid", array($this->token, $gid, $paid), "I");
	}

	function setDocumentStorno($gid, $storno) {
		return $this->_do_command("setDocumentStorno", array($this->token, $gid, $storno), "I");
	}

	function createInvoiceFromTicket($gid, $issueDate, $deliveryDate, $advancePayment, $maturityDays, $prepaid) {
		return $this->_do_command("createInvoiceFromTicket", array($this->token, $gid, $issueDate, $deliveryDate, $advancePayment, $maturityDays, $prepaid), "I");
	}

}

/*
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE

require_once("ealibInvoicing.php");

$eai = new ElbiaAdminInvoicing("login", "heslo");

$result = $eai->listDocuments(0, 10, NULL, NULL, NULL, 1);

print_r($result);

*/
?>
