<?php
/*
 *
 * ElbiaAdmin PHP-lib version 3.1.9
 * Copyright (c) 2009-2024, Jozef Sudolsky, ELBIA, s. r. o. (jozef@sudolsky.sk)
 * All rights reserved.
 * BSD Licence
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     1. Redistributions of source code must retain the above copyright notice,
 *        this list of conditions and the following disclaimer.
 *
 *     2. Redistributions in binary form must reproduce the above copyright
 *        notice, this list of conditions and the following disclaimer in the
 *        documentation and/or other materials provided with the distribution.
 *
 *     3. Neither the name of ElbiaAdmin PHP-lib nor the names of its
 *        contributors may be used to endorse or promote products derived from
 *        this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

require_once("ealibCore.php");

class ElbiaAdminWebhosting extends ElbiaAdmin {

	function get_email_account($acc_id) {
		return $this->_do_command("get_email_account", array($this->token, $acc_id), "M");
	}

	function get_email_accounts($domain, $tld, $poffset, $pcount, $fname=NULL) {
		return $this->_do_command("get_email_accounts", array($this->token, $domain, $tld, $poffset, $pcount, $fname), "M");
	}

	function add_email_account($name, $domain, $tld, $password, $catchall, $antispam) {
		return $this->_do_command("add_email_account", array($this->token, $name, $domain, $tld, $password, $catchall, $antispam), "M");
	}

	function change_email_account($email_id, $password, $catchall, $antispam, $bcc_in=NULL, $bcc_out=NULL) {
		return $this->_do_command("change_email_account", array($this->token, $email_id, $password, $catchall, $antispam, $bcc_in, $bcc_out), "M");
	}

	function remove_email_account($email_id) {
		return $this->_do_command("remove_email_account", array($this->token, $email_id), "M");
	}

	function get_email_autoreply($email_id) {
		return $this->_do_command("get_email_autoreply", array($this->token, $email_id), "M");
	}

	function change_email_autoreply($id_email, $subject, $text, $content_type, $forward, $activate, $deactivate, $dayw, $active) {
		return $this->_do_command("change_email_autoreply", array($this->token, $id_email, $subject, $text, $content_type, $forward, $activate, $deactivate, $dayw, $active), "M");
	}

	function get_email_filters($email_id) {
		return $this->_do_command("get_email_filters", array($this->token, $email_id), "M");
	}

	function get_email_filter($filter_id) {
		return $this->_do_command("get_email_filter", array($this->token, $filter_id), "M");
	}

	function add_email_filter($email_id, $name, $conditions_type, $action, $action_info, $rules) {
		return $this->_do_command("add_email_filter", array($this->token, $email_id, $name, $conditions_type, $action, $action_info, $rules), "M");
	}

	function change_email_filter($filter_id, $name) {
		return $this->_do_command("change_email_filter", array($this->token, $filter_id, $name), "M");
	}

	function activate_email_filter($filter_id) {
		return $this->_do_command("activate_email_filter", array($this->token, $filter_id), "M");
	}

	function deactivate_email_filter($filter_id) {
		return $this->_do_command("deactivate_email_filter", array($this->token, $filter_id), "M");
	}

	function remove_email_filter($filter_id) {
		return $this->_do_command("remove_email_filter", array($this->token, $filter_id), "M");
	}

	function get_email_aliases($domain, $tld, $poffset, $pcount, $fname=NULL, $faccount=NULL) {
		return $this->_do_command("get_email_aliases", array($this->token, $domain, $tld, $poffset, $pcount, $fname, $faccount), "M");
	}

	function add_email_alias($name, $account_id) {
		return $this->_do_command("add_email_alias", array($this->token, $name, $account_id), "M");
	}

	function remove_email_alias($alias_id) {
		return $this->_do_command("remove_email_alias", array($this->token, $alias_id), "M");
	}

	function get_email_forwards($domain, $tld, $poffset, $pcount, $fname=NULL, $femails=NULL) {
		return $this->_do_command("get_email_forwards", array($this->token, $domain, $tld, $poffset, $pcount, $fname, $femails), "M");
	}

	function get_email_forward($account_id) {
		return $this->_do_command("get_email_forward", array($this->token, $account_id), "M");
	}

	function add_email_forward($account_id, $emails, $save) {
		return $this->_do_command("add_email_forward", array($this->token, $account_id, $emails, $save), "M");
	}

	function change_email_forward($account_id, $emails, $save) {
		return $this->_do_command("change_email_forward", array($this->token, $account_id, $emails, $save), "M");
	}

	function remove_email_forward($account_id) {
		return $this->_do_command("remove_email_forward", array($this->token, $account_id), "M");
	}

	function get_quota() {
		return $this->_do_command("get_quota", array($this->token), "W");
	}

	function list_dir($directory, $files=0) {
		return $this->_do_command("list_dir", array($this->token, $directory, $files), "W");
	}

	function create_dir($directory, $name) {
		return $this->_do_command("create_dir", array($this->token, $directory, $name), "W");
	}

	function get_ftp_account($ftp_id) {
		return $this->_do_command("get_ftp_account", array($this->token, $ftp_id), "W");
	}

	function get_ftp_accounts($poffset, $pcount, $fuserid=NULL, $fhomedir=NULL) {
		return $this->_do_command("get_ftp_accounts", array($this->token, $poffset, $pcount, $fuserid, $fhomedir), "W");
	}

	function add_ftp_account($login, $password, $directory) {
		return $this->_do_command("add_ftp_account", array($this->token, $login, $password, $directory), "W");
	}

	function change_ftp_account($ftp_id, $password, $directory) {
		return $this->_do_command("change_ftp_account", array($this->token, $ftp_id, $password, $directory), "W");
	}

	function activate_ftp_account($ftp_id) {
		return $this->_do_command("activate_ftp_account", array($this->token, $ftp_id), "W");
	}

	function deactivate_ftp_account($ftp_id) {
		return $this->_do_command("deactivate_ftp_account", array($this->token, $ftp_id), "W");
	}

	function remove_ftp_account($ftp_id) {
		return $this->_do_command("remove_ftp_account", array($this->token, $ftp_id), "W");
	}

	function get_ftp_ipfilters($ftp_id) {
		return $this->_do_command("get_ftp_ipfilters", array($this->token, $ftp_id), "W");
	}

	function add_ftp_ipfilter($ftp_id, $rule, $rtype, $label) {
		return $this->_do_command("add_ftp_ipfilter", array($this->token, $ftp_id, $rule, $rtype, $label), "W");
	}

	function remove_ftp_ipfilter($rule_id) {
		return $this->_do_command("remove_ftp_ipfilter", array($this->token, $rule_id), "W");
	}

	function get_logs($domain, $tld, $ltype) {
		return $this->_do_command("get_logs", array($this->token, $domain, $tld, $ltype), "W");
	}

	function show_log($domain, $tld, $ltype, $log) {
		return $this->_do_command("show_log", array($this->token, $domain, $tld, $ltype, $log), "W");
	}

	function copy_log($domain, $tld, $ltype, $log) {
		return $this->_do_command("copy_log", array($this->token, $domain, $tld, $ltype, $log), "W");
	}

	function get_subdomains($domain, $tld, $poffset, $pcount, $fsubdomain=NULL, $frootdir=NULL, $fjail=NULL) {
		return $this->_do_command("get_subdomains", array($this->token, $domain, $tld, $poffset, $pcount, $fsubdomain, $frootdir, $fjail), "W");
	}

	function get_subdomain($sub_id) {
		return $this->_do_command("get_subdomain", array($this->token, $sub_id), "W");
	}

	function add_subdomain($subdomain, $domain, $tld, $directory, $jail, $https, $force_https, $redirect, $https_certificate, $https_private_key, $https_ca_certificate, $id_php, $php_private_pool, $php_file_cache, $wsgi, $firewall) {
		return $this->_do_command("add_subdomain", array($this->token, $subdomain, $domain, $tld, $directory, $jail, $https, $force_https, $redirect, $https_certificate, $https_private_key, $https_ca_certificate, $id_php, $php_private_pool, $php_file_cache, $wsgi, $firewall), "W");
	}

	function change_subdomain($sub_id, $directory, $jail, $https, $force_https, $redirect, $https_certificate, $https_private_key, $https_ca_certificate, $id_php, $php_private_pool, $php_file_cache, $wsgi, $firewall) {
		return $this->_do_command("change_subdomain", array($this->token, $sub_id, $directory, $jail, $https, $force_https, $redirect, $https_certificate, $https_private_key, $https_ca_certificate, $id_php, $php_private_pool, $php_file_cache, $wsgi, $firewall), "W");
	}

	function remove_subdomain($sub_id) {
		return $this->_do_command("remove_subdomain", array($this->token, $sub_id), "W");
	}

	function get_subdomain_software_info($sub_id) {
		return $this->_do_command("get_subdomain_software_info", array($this->token, $sub_id), "W");
	}

	function change_subdomain_software_info($sub_id, $info) {
		return $this->_do_command("change_subdomain_software_info", array($this->token, $sub_id, $info), "W");
	}

	function get_supported_phps() {
		return $this->_do_command("get_supported_phps", array($this->token), "W");
	}

	function get_mysql_accounts($poffset, $pcount, $fuser=NULL, $fhost=NULL) {
		return $this->_do_command("get_mysql_accounts", array($this->token, $poffset, $pcount, $fuser, $fhost), "W");
	}

	function add_mysql_account($login, $host, $password) {
		return $this->_do_command("add_mysql_account", array($this->token, $login, $host, $password), "W");
	}

	function change_mysql_account($acc_id, $host, $password) {
		return $this->_do_command("change_mysql_account", array($this->token, $acc_id, $host, $password), "W");
	}

	function remove_mysql_account($acc_id) {
		return $this->_do_command("remove_mysql_account", array($this->token, $acc_id), "W");
	}

	function get_mysql_encodings() {
		return $this->_do_command("get_mysql_encodings", array($this->token), "W");
	}

	function get_mysql_databases($poffset, $pcount, $fdb=NULL) {
		return $this->_do_command("get_mysql_databases", array($this->token, $poffset, $pcount, $fdb), "W");
	}

	function get_mysql_database($db_id) {
		return $this->_do_command("get_mysql_database", array($this->token, $db_id), "W");
	}

	function add_mysql_database($name, $encoding, $account) {
		return $this->_do_command("add_mysql_database", array($this->token, $name, $encoding, $account), "W");
	}

	function change_mysql_database($db_id, $account) {
		return $this->_do_command("change_mysql_database", array($this->token, $db_id, $account), "W");
	}

	function remove_mysql_database($db_id) {
		return $this->_do_command("remove_mysql_database", array($this->token, $db_id), "W");
	}

	function restore_mysql_database($db_id) {
		return $this->_do_command("restore_mysql_database", array($this->token, $db_id), "W");
	}

	function get_crons($poffset, $pcount, $fname=NULL, $femail=NULL, $fcfile=NULL, $fsubdomain=NULL, $fdomain=NULL, $ftld=NULL, $furl=NULL) {
		return $this->_do_command("get_crons", array($this->token, $poffset, $pcount, $fname, $femail, $fcfile, $fsubdomain, $fdomain, $ftld, $furl), "W");
	}

	function get_cron($cron_id) {
		return $this->_do_command("get_cron", array($this->token, $cron_id), "W");
	}

	function add_cron($name, $email, $ctype, $cfile, $parameters, $proto, $subdomain, $domain, $tld, $url, $auth_login, $auth_password, $minute, $hour, $day, $month, $dayw) {
		return $this->_do_command("add_cron", array($this->token, $name, $email, $ctype, $cfile, $parameters, $proto, $subdomain, $domain, $tld, $url, $auth_login, $auth_password, $minute, $hour, $day, $month, $dayw), "W");
	}

	function change_cron($cron_id, $name, $email, $ctype, $cfile, $parameters, $proto, $subdomain, $domain, $tld, $url, $auth_login, $auth_password, $minute, $hour, $day, $month, $dayw) {
		return $this->_do_command("change_cron", array($this->token, $cron_id, $name, $email, $ctype, $cfile, $parameters, $proto, $subdomain, $domain, $tld, $url, $auth_login, $auth_password, $minute, $hour, $day, $month, $dayw), "W");
	}

	function remove_cron($cron_id) {
		return $this->_do_command("remove_cron", array($this->token, $cron_id), "W");
	}

	function get_webhosting_info() {
		return $this->_do_command("get_webhosting_info", array($this->token), "DI");
	}

	function get_webhosting_ip_addresses($get_domains=0) {
		return $this->_do_command("get_webhosting_ip_addresses", array($this->token, $get_domains), "DI");
	}

	function renew_webhosting() {
		return $this->_do_command("renew_webhosting", array($this->token), "DI");
	}

	function renew_webhosting_domain($dom_id) {
		return $this->_do_command("renew_webhosting_domain", array($this->token, $dom_id), "DI");
	}

	function get_webhosting_domain($dom_id) {
		return $this->_do_command("get_webhosting_domain", array($this->token, $dom_id), "DI");
	}

	function get_webhosting_domain_by_name($domain, $tld) {
		return $this->_do_command("get_webhosting_domain_by_name", array($this->token, $domain, $tld), "DI");
	}

	function get_webhosting_domains($poffset, $pcount, $fdomain=NULL, $ftld=NULL, $fexpirationfrom=NULL, $fexpirationto=NULL, $fipv4=NULL, $fipv6=NULL) {
		return $this->_do_command("get_webhosting_domains", array($this->token, $poffset, $pcount, $fdomain, $ftld, $fexpirationfrom, $fexpirationto, $fipv4, $fipv6), "DI");
	}

	function add_webhosting_domain($domain, $tld, $id_ip, $id_domain) {
		return $this->_do_command("add_webhosting_domain", array($this->token, $domain, $tld, $id_ip, $id_domain), "DI");
	}

	function change_webhosting_domain($dom_id, $id_ip) {
		return $this->_do_command("change_webhosting_domain", array($this->token, $dom_id, $id_ip), "DI");
	}

	function change_webhosting_domain_dns_servers($dom_id, $ns1, $ns2, $ns3, $ns4, $ip1, $ip2, $ip3, $ip4, $nsset) {
		return $this->_do_command("change_webhosting_domain_dns_servers", array($this->token, $dom_id, $ns1, $ns2, $ns3, $ns4, $ip1, $ip2, $ip3, $ip4, $nsset), "DI");
	}

	function remove_webhosting_domain($dom_id) {
		return $this->_do_command("remove_webhosting_domain", array($this->token, $dom_id), "DI");
	}

	function register_webhosting_domain($domain, $tld, $owner) {
		return $this->_do_command("register_webhosting_domain", array($this->token, $domain, $tld, $owner), "DI");
	}

	function get_domain_dns_records($domain, $tld) {
		return $this->_do_command("get_domain_dns_records", array($this->token, $domain, $tld), "D");
	}

	function get_domain_dns_record($record_id) {
		return $this->_do_command("get_domain_dns_record", array($this->token, $record_id), "D");
	}

	function add_domain_dns_record($domain, $tld, $name, $rtype, $content, $ttl, $prio) {
		return $this->_do_command("add_domain_dns_record", array($this->token, $domain, $tld, $name, $rtype, $content, $ttl, $prio), "D");
	}

	function change_domain_dns_record($record_id, $name, $rtype, $content, $ttl, $prio) {
		return $this->_do_command("change_domain_dns_record", array($this->token, $record_id, $name, $rtype, $content, $ttl, $prio), "D");
	}

	function remove_domain_dns_record($record_id) {
		return $this->_do_command("remove_domain_dns_record", array($this->token, $record_id), "D");
	}

	function set_stats_password($domain, $tld, $login, $password) {
		return $this->_do_command("set_stats_password", array($this->token, $domain, $tld, $login, $password), "W");
	}

	function add_temporary_url($sub_id) {
		return $this->_do_command("add_temporary_url", array($this->token, $sub_id), "W");
	}

	function get_running_processes() {
		return $this->_do_command("get_running_processes", array($this->token), "W");
	}

	function kill_running_process($pid) {
		return $this->_do_command("kill_running_process", array($this->token, $pid), "W");
	}

	function get_mysql_running_processes() {
		return $this->_do_command("get_mysql_running_processes", array($this->token), "W");
	}

	function kill_mysql_running_process($pid) {
		return $this->_do_command("kill_mysql_running_process", array($this->token, $pid), "W");
	}

	function get_webhosting_tlds() {
		return $this->_do_command("get_webhosting_tlds", array($this->token), "DI");
	}

	function import_info($id_email) {
		return $this->_do_command("import_info", array($this->token, $id_email), "M");
	}

	function start_import($id_email, $host, $port, $login, $password, $ssl, $email) {
		return $this->_do_command("start_import", array($this->token, $id_email, $host, $port, $login, $password, $ssl, $email), "M");
	}

	function install_software_subdomain($sub_id, $software, $email, $site_name) {
		return $this->_do_command("install_software_subdomain", array($this->token, $sub_id, $software, $email, $site_name), "W");
	}

	function change_ssh_password($password) {
		return $this->_do_command("change_ssh_password", array($this->token, $password), "W");
	}

	function get_webhosting_cpu_graph($period) {
		return $this->_do_command("get_webhosting_cpu_graph", array($this->token, $period), "DI");
	}

}
/*
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE
EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE EXAMPLE

$eaw = new ElbiaAdminWebhosting("login", "heslo");

$result = $eaw->get_webhosting_domains(0, 0);

print_r($result);
echo "<br>";

$result = $eaw->get_email_accounts("inetadmin", "eu", 0, 0);

print_r($result);
echo "<br>";

$result = $eaw->add_email_account("info", "inetadmin", "eu", "dd", 0);

print_r($result);
echo "<br>";

$result = $eaw->change_email_account(1108, "ff", 0);

print_r($result);
echo "<br>";

$result = $eaw->remove_email_account(1108);

print_r($result);
echo "<br>";
*/
?>
